top :-
    regions(Rs),
    solve(Rs,[],P).

regions(Rs):-
    Rs=[1,2,3,4,5,6,7,8,9,10,
                 11,12,13,14,15,16,17,18,19,20,
                 21,22,23,24,25,26,27,28,29,30,
                 31,32,33,34,35,36,37,38,39,40,
                 41,42,43,44,45,46,47,48,49,50,
                 51,52,53,54,55,56,57,58,59,60,
                 61,62,63,64,65,66,67,68,69,70,
                 71,72,73,74,75,76,77,78,79,80,
                 81,82,83,84,85,86,87,88,89,90,
                 91,92,93,94,95,96,97,98,99,100,
                 101,102,103,104,105,106,107,108,109,110].

solve([],P0,Pn):-
    Pn=P0.
solve([R|Rs],P0,Pn):-
    color(C),
    consistent(R,C,P0),
    solve(Rs,[region(R,C)|P0],Pn).

consistent(R,C,[]).
consistent(R,C,[region(R1,C)|P]):-
    neighbor(R1,R),!,
    fail.
consistent(R,C,[_|P]):-
    consistent(R,C,P).

color(X):-X=red.
color(X):-X=blue.
color(X):-X=black.
color(X):-X=yellow.


neighbor(1,2).
neighbor(1,3).
neighbor(1,4).
neighbor(1,5).
neighbor(1,6).
neighbor(1,7).
neighbor(1,8).
neighbor(1,9).
neighbor(1,10).
neighbor(1,11).
neighbor(1,20).
neighbor(1,73).
neighbor(1,109).
neighbor(1,110).
neighbor(2,3).
neighbor(2,12).
neighbor(2,57).
neighbor(2,102).
neighbor(2,103).
neighbor(2,104).
neighbor(2,105).
neighbor(2,106).
neighbor(2,110).
neighbor(3,4).
neighbor(3,12).
neighbor(3,13).
neighbor(4,5).
neighbor(4,13).
neighbor(4,14).
neighbor(5,6).
neighbor(5,14).
neighbor(5,15).
neighbor(6,7).
neighbor(6,15).
neighbor(6,16).
neighbor(7,8).
neighbor(7,16).
neighbor(7,17).
neighbor(8,9).
neighbor(8,17).
neighbor(8,18).
neighbor(9,10).
neighbor(9,18).
neighbor(9,19).
neighbor(10,11).
neighbor(10,19).
neighbor(10,20).
neighbor(11,20).
neighbor(12,13).
neighbor(12,21).
neighbor(12,57).
neighbor(12,58).
neighbor(13,14).
neighbor(13,21).
neighbor(13,22).
neighbor(14,15).
neighbor(14,22).
neighbor(14,23).
neighbor(15,16).
neighbor(15,23).
neighbor(15,24).
neighbor(16,17).
neighbor(16,24).
neighbor(16,25).
neighbor(17,18).
neighbor(17,25).
neighbor(17,26).
neighbor(18,19).
neighbor(18,26).
neighbor(18,27).
neighbor(19,20).
neighbor(19,27).
neighbor(19,28).
neighbor(20,28).
neighbor(20,73).
neighbor(21,22).
neighbor(21,29).
neighbor(21,58).
neighbor(21,59).
neighbor(22,23).
neighbor(22,29).
neighbor(22,30).
neighbor(23,24).
neighbor(23,30).
neighbor(23,31).
neighbor(24,25).
neighbor(24,31).
neighbor(24,32).
neighbor(25,26).
neighbor(25,32).
neighbor(25,33).
neighbor(26,27).
neighbor(26,33).
neighbor(26,34).
neighbor(27,28).
neighbor(27,34).
neighbor(27,35).
neighbor(28,35).
neighbor(28,72).
neighbor(28,73).
neighbor(29,30).
neighbor(29,36).
neighbor(29,59).
neighbor(29,60).
neighbor(30,31).
neighbor(30,36).
neighbor(30,37).
neighbor(31,32).
neighbor(31,37).
neighbor(31,38).
neighbor(32,33).
neighbor(32,38).
neighbor(32,39).
neighbor(33,34).
neighbor(33,39).
neighbor(33,40).
neighbor(34,35).
neighbor(34,40).
neighbor(34,41).
neighbor(35,41).
neighbor(35,71).
neighbor(35,72).
neighbor(36,37).
neighbor(36,42).
neighbor(36,60).
neighbor(36,61).
neighbor(37,38).
neighbor(37,42).
neighbor(37,43).
neighbor(38,39).
neighbor(38,43).
neighbor(38,44).
neighbor(39,40).
neighbor(39,44).
neighbor(39,45).
neighbor(40,41).
neighbor(40,45).
neighbor(40,46).
neighbor(41,46).
neighbor(41,70).
neighbor(41,71).
neighbor(42,43).
neighbor(42,47).
neighbor(42,61).
neighbor(42,62).
neighbor(43,44).
neighbor(43,47).
neighbor(43,48).
neighbor(44,45).
neighbor(44,48).
neighbor(44,49).
neighbor(45,46).
neighbor(45,49).
neighbor(45,50).
neighbor(46,50).
neighbor(46,69).
neighbor(46,70).
neighbor(47,48).
neighbor(47,51).
neighbor(47,62).
neighbor(47,63).
neighbor(48,49).
neighbor(48,51).
neighbor(48,52).
neighbor(49,50).
neighbor(49,52).
neighbor(49,53).
neighbor(50,53).
neighbor(50,68).
neighbor(50,69).
neighbor(51,52).
neighbor(51,54).
neighbor(51,63).
neighbor(51,64).
neighbor(52,53).
neighbor(52,54).
neighbor(52,55).
neighbor(53,55).
neighbor(53,67).
neighbor(53,68).
neighbor(54,55).
neighbor(54,56).
neighbor(54,64).
neighbor(54,65).
neighbor(55,56).
neighbor(55,66).
neighbor(55,67).
neighbor(56,65).
neighbor(56,66).
neighbor(57,58).
neighbor(57,102).
neighbor(58,59).
neighbor(58,95).
neighbor(58,102).
neighbor(59,60).
neighbor(59,89).
neighbor(59,95).
neighbor(60,61).
neighbor(60,84).
neighbor(60,89).
neighbor(61,62).
neighbor(61,80).
neighbor(61,84).
neighbor(62,63).
neighbor(62,77).
neighbor(62,80).
neighbor(63,64).
neighbor(63,75).
neighbor(63,77).
neighbor(64,65).
neighbor(64,74).
neighbor(64,75).
neighbor(65,66).
neighbor(65,74).
neighbor(66,67).
neighbor(66,74).
neighbor(67,68).
neighbor(67,74).
neighbor(67,76).
neighbor(68,69).
neighbor(68,76).
neighbor(68,79).
neighbor(69,70).
neighbor(69,79).
neighbor(69,83).
neighbor(70,71).
neighbor(70,83).
neighbor(70,88).
neighbor(71,72).
neighbor(71,88).
neighbor(71,94).
neighbor(72,73).
neighbor(72,94).
neighbor(72,101).
neighbor(73,101).
neighbor(73,109).
neighbor(74,75).
neighbor(74,76).
neighbor(75,76).
neighbor(75,77).
neighbor(75,78).
neighbor(76,78).
neighbor(76,79).
neighbor(77,78).
neighbor(77,80).
neighbor(77,81).
neighbor(78,79).
neighbor(78,81).
neighbor(78,82).
neighbor(79,82).
neighbor(79,83).
neighbor(80,81).
neighbor(80,84).
neighbor(80,85).
neighbor(81,82).
neighbor(81,85).
neighbor(81,86).
neighbor(82,83).
neighbor(82,86).
neighbor(82,87).
neighbor(83,87).
neighbor(83,88).
neighbor(84,85).
neighbor(84,89).
neighbor(84,90).
neighbor(85,86).
neighbor(85,90).
neighbor(85,91).
neighbor(86,87).
neighbor(86,91).
neighbor(86,92).
neighbor(87,88).
neighbor(87,92).
neighbor(87,93).
neighbor(88,93).
neighbor(88,94).
neighbor(89,90).
neighbor(89,95).
neighbor(89,96).
neighbor(90,91).
neighbor(90,96).
neighbor(90,97).
neighbor(91,92).
neighbor(91,97).
neighbor(91,98).
neighbor(92,93).
neighbor(92,98).
neighbor(92,99).
neighbor(93,94).
neighbor(93,99).
neighbor(93,100).
neighbor(94,100).
neighbor(94,101).
neighbor(95,96).
neighbor(95,102).
neighbor(95,103).
neighbor(96,97).
neighbor(96,103).
neighbor(96,104).
neighbor(97,98).
neighbor(97,104).
neighbor(97,105).
neighbor(98,99).
neighbor(98,105).
neighbor(98,106).
neighbor(99,100).
neighbor(99,106).
neighbor(99,107).
neighbor(100,101).
neighbor(100,107).
neighbor(100,108).
neighbor(101,108).
neighbor(101,109).
neighbor(102,103).
neighbor(103,104).
neighbor(104,105).
neighbor(105,106).
neighbor(106,107).
neighbor(106,110).
neighbor(107,108).
neighbor(107,110).
neighbor(108,109).
neighbor(108,110).
neighbor(109,110).
