top :- true : 
    mklist(1000,L),
    nrev(L,L1).

mklist(N,L):-
    N=:=0 :
    L:=[].
mklist(N,L):-
    true :
    L:=[N|L1],
    N1 is N-1,
    mklist(N1,L1).

nrev([],L):-
    true :
    L:=[].
nrev([X|Xs],L):-
    true :
    nrev(Xs,L1),
    concat(L1,[X],L).


concat([],L1,L2):-
    true :
    L2:=L1.
concat([X|Xs],L1,L2):-
    true :
    L2:=[X|L3],
    concat(Xs,L1,L3).
