extern char *string_in;
extern int lastc;

char*
getline(char *prompt)
{
	char *x, *r;

	static int n;
	static char buf[1024];
	static char *p;

	if(prompt)
		write(1, prompt, strlen(prompt));

	for(;;){
		if(n == 0 || p >= buf+n){
			n = read(0, buf, sizeof buf-1);
			p = buf;
		}
		for(x=p; x < buf+n && *x != '\n'; x++)
			;
		if(x < buf+n)
			break;
		n = 0;
	}

	*x = 0;
	r = p;
	p = x+1;
	return r;
}

int
c_GET_NONEMPTY_LINE(void)
{
	char *r;

	for(;;){
		r = getline("?- ");
		while(r && *r && (*r==' ' || *r=='\t'))
			r++;
		if(r && *r)
			break;
	}
	string_in = r;
	lastc = ' ';
	return 1;
}

int
c_FINISH_GET_LINE(void)
{
	string_in = 0;
	lastc = ' ';
	return 1;
}

