/* builtins.c */
#include "basic.h"
#include "term.h"
#include "macro.h"
#define MAXBS 105

int (*builtins[MAXBS])();
  
extern int b_ACCESS_ccf();
extern int b_ASPN2_cc();
extern int b_ASPN3_ccc();
extern int b_ASPN4_cccc();
extern int b_ASPN_c();
extern int b_ASSERTABLE_c();
extern int b_ASSERTA_HASHTAB_cc();
extern int b_ASSERTA_TMP_cf();
extern int b_ASSERT_STATIC_TMP_c();
extern int b_ASSERT_TMP_cf();
extern int b_BLDATOM_fc();
extern int b_CLOSE_c();
extern int b_COMPARE_fcc();
/* extern int b_COPY_UNNUMBER_VARS_cf(); */
extern int b_CPUTIME_f();
extern int b_CURRENT_INPUT_f();
extern int b_CURRENT_OUTPUT_f();
extern int b_DESTRUCTIVE_SET_ARG_ccc();
extern int b_DM_COUNT_cf();
/* extern int b_DM_CREATE_cc(); */
extern int b_DM_MIN_MAX_cff();
extern int b_DM_MIN_cf();
extern int b_DM_MAX_cf();
extern int b_DM_NEXT_ccf();
extern int b_DM_PREV_ccf(); 
extern int b_DM_TRUE_cc();
extern int b_EVAL_ARITH_cf();
extern int b_FLOAT_ABS_cf();
extern int b_FLOAT_ATAN_cf();
extern int b_FLOAT_CEILING_cf();
extern int b_FLOAT_COS_cf();
extern int b_FLOAT_EXP_cf();
extern int b_FLOAT_FLOAT_cf();
extern int b_FLOAT_FLOOR_cf();
extern int b_FLOAT_LOG_cf();
extern int b_FLOAT_MINUS_cf();
extern int b_FLOAT_POW_ccf();
extern int b_FLOAT_ROUND_cf();
extern int b_FLOAT_SIN_cf();
extern int b_FLOAT_SQRT_cf();
extern int b_FLOAT_TAN_cf();
extern int b_FLOAT_TRUNCATE_cf();
extern int b_FLOAT_WRITE_c();
extern int b_FLUSH_OUTPUT();
extern int b_GET0_f();
extern int b_GET_CLAUSES_cf();
extern int b_GET_LENGTH_cf();
extern int b_GET_SYM_TYPE_ccf();
extern int b_GET_f();
extern int b_GLOBAL_CLAUSE_NO_f();
extern int b_GLOBAL_CREATE_cccc();
extern int b_GLOBAL_DEL_cc();
extern int b_GLOBAL_GET_ccf();
extern int b_GLOBAL_INSERT_HEAD_cccc();
extern int b_GLOBAL_INSERT_TAIL_ccc();
extern int b_GLOBAL_REMOVE_CLAUSE_ccc();
extern int b_GLOBAL_SET_ccc();
extern int b_GLOBAL_SET_cccc();
extern int b_HASHVAL1_cf();
extern int b_HASHVAL_cf();
extern int b_ISGLOBAL_cc();
extern int b_IS_CONSULTED_c();
extern int b_IS_DYNAMIC_cc();
extern int b_IS_ORDINARY_cc();
extern int b_LOAD_cfc();
extern int b_NAME0_cf();
extern int b_NEXT_TOKEN_ff();
extern int b_NL();
extern int b_NORMAL_ATOM_c();
extern int b_OPEN_ccf();
extern int b_PUT_c();
extern int b_RETRACTABLE_c();
extern int b_SEEING_f();
extern int b_SEEN();
extern int b_SEE_c();
extern int b_SET_DYNAMIC_cc();
extern int b_SET_INPUT_c();
extern int b_SET_OUTPUT_c();
extern int b_SYSTEM0_cf();
extern int b_TAB_c();
extern int b_TELLING_f();
extern int b_TELL_cc();
extern int b_TOLD();
extern int b_UNIV_cf();
extern int b_UNIV_fc();
extern int b_WRITENAME_c();
extern int b_WRITEQNAME_c();
extern int b_WRITEQ_QUICK_c();
extern int b_WRITE_IMAGE_c();
extern int b_WRITE_QUICK_c();
extern int b_XOR_ccf();
extern int b_FLOAT_SIGN_cf();
extern int dvar_or_int();
extern int b_CONSTRAINTS_NUMBER_cf();
extern int dvar();
extern int b_deleteff();
extern int b_deleteffc();
extern int dvar_bv();

init_builtins(){
   builtins[1]=b_ACCESS_ccf;
   builtins[2]=b_ASPN2_cc;
   builtins[3]=b_ASPN3_ccc;
   builtins[4]=b_ASPN4_cccc;
   builtins[5]=b_ASPN_c;
   builtins[6]=b_ASSERTABLE_c;
   builtins[7]=b_ASSERTA_HASHTAB_cc;
   builtins[8]=b_ASSERTA_TMP_cf;
   builtins[9]=b_ASSERT_STATIC_TMP_c;
   builtins[10]=b_ASSERT_TMP_cf;
   builtins[11]=b_BLDATOM_fc;
   builtins[12]=b_CLOSE_c;
   builtins[13]=b_COMPARE_fcc;
/*    builtins[16]=b_COPY_UNNUMBER_VARS_cf; */
   builtins[17]=b_CPUTIME_f;
   builtins[18]=b_CURRENT_INPUT_f;
   builtins[19]=b_CURRENT_OUTPUT_f;
   builtins[20]=b_DESTRUCTIVE_SET_ARG_ccc;
   builtins[21]=b_DM_COUNT_cf;
/*   builtins[22]=b_DM_CREATE_cc; */
   builtins[22]=b_DM_MIN_MAX_cff;
/*   builtins[23]=boolean_var; */
   builtins[24]=b_DM_PREV_ccf;
   builtins[25]=b_DM_NEXT_ccf;
   builtins[26]=b_DM_TRUE_cc;
   builtins[27]=b_EVAL_ARITH_cf;
   builtins[28]=b_FLOAT_ABS_cf;
   builtins[29]=b_FLOAT_ATAN_cf;
   builtins[30]=b_FLOAT_CEILING_cf;
   builtins[31]=b_FLOAT_COS_cf;
   builtins[32]=b_FLOAT_EXP_cf;
   builtins[33]=b_FLOAT_FLOAT_cf;
   builtins[34]=b_FLOAT_FLOOR_cf;
   builtins[35]=b_FLOAT_LOG_cf;
   builtins[36]=b_FLOAT_MINUS_cf;
   builtins[37]=b_FLOAT_POW_ccf;
   builtins[38]=b_FLOAT_ROUND_cf;
   builtins[39]=b_FLOAT_SIN_cf;
   builtins[40]=b_FLOAT_SQRT_cf;
   builtins[41]=b_FLOAT_TAN_cf;
   builtins[42]=b_FLOAT_TRUNCATE_cf;
   builtins[43]=b_FLOAT_WRITE_c;
   builtins[44]=b_FLUSH_OUTPUT;
   builtins[45]=b_GET0_f;
   builtins[46]=b_GET_CLAUSES_cf;
   builtins[48]=b_GET_LENGTH_cf;
   builtins[49]=b_GET_SYM_TYPE_ccf;
   builtins[50]=b_GET_f;
   builtins[51]=b_GLOBAL_CLAUSE_NO_f;
   builtins[52]=b_GLOBAL_CREATE_cccc;
   builtins[53]=b_GLOBAL_DEL_cc;
   builtins[54]=b_GLOBAL_GET_ccf;
   builtins[55]=b_GLOBAL_INSERT_HEAD_cccc;
   builtins[56]=b_GLOBAL_INSERT_TAIL_ccc;
   builtins[57]=b_GLOBAL_REMOVE_CLAUSE_ccc;
   builtins[58]=b_GLOBAL_SET_ccc;
   builtins[59]=b_GLOBAL_SET_cccc;
   builtins[60]=b_HASHVAL1_cf;
   builtins[61]=b_HASHVAL_cf;
   builtins[63]=b_ISGLOBAL_cc;
   builtins[64]=b_IS_CONSULTED_c;
   builtins[65]=b_IS_DYNAMIC_cc;
   builtins[66]=b_IS_ORDINARY_cc;
   builtins[67]=b_LOAD_cfc;
   builtins[68]=b_NAME0_cf;
   builtins[69]=b_NEXT_TOKEN_ff;
   builtins[70]=b_NL;
   builtins[71]=b_NORMAL_ATOM_c;
   builtins[72]=b_OPEN_ccf;
   builtins[73]=b_PUT_c;
   builtins[74]=b_RETRACTABLE_c;
   builtins[75]=b_SEEING_f;
   builtins[76]=b_SEEN;
   builtins[77]=b_SEE_c;
   builtins[78]=b_SET_DYNAMIC_cc;
   builtins[80]=b_SET_INPUT_c;
   builtins[81]=b_SET_OUTPUT_c;
   builtins[82]=b_SYSTEM0_cf;
   builtins[83]=b_TAB_c;
   builtins[84]=b_TELLING_f;
   builtins[85]=b_TELL_cc;
   builtins[86]=b_TOLD;
   builtins[87]=b_UNIV_cf;
   builtins[88]=b_UNIV_fc;
   builtins[89]=b_WRITENAME_c;
   builtins[90]=b_WRITEQNAME_c;
   builtins[91]=b_WRITEQ_QUICK_c;
   builtins[92]=b_WRITE_IMAGE_c;
   builtins[93]=b_WRITE_QUICK_c;
   builtins[94]=b_XOR_ccf;
   builtins[95]=b_FLOAT_SIGN_cf;
   builtins[96]=dvar_or_int; 
   builtins[97]=b_CONSTRAINTS_NUMBER_cf;
   builtins[98]=dvar;
   builtins[99]=b_deleteff;
   builtins[100]=b_deleteffc;
   builtins[101]=b_DM_MIN_cf;
   builtins[102]=b_DM_MAX_cf;
   builtins[103]=dvar_bv; 
}


