#include "basic.h"
#include "term.h"
#include "macro.h"

#define NUMVARS_MAX 26

SYM_REC_PTR dollar_var,dollar_float,dollar_and;

Cboot_numbervars()
{
  SYM_REC_PTR insert_cfunc();

  dollar_var = insert_cfunc("$VAR",1);
  dollar_float = insert_cfunc("$float",3);
  dollar_and = insert_cfunc(",",2);
}

c_NUMBER_VARS(){
  register LONG op1,op2,op3;
  register LONG_PTR top;
  
  op1 = ARG(1,3); op2 = ARG(2,3); op3 = ARG(3,3);
  
  DEREF(op2);
  if (!ISINT(op2)) {
    exception = integer_expected;
    return -1;
  }
  op1 = aux_number_vars__3(op1,INTVAL(op2));
  if (op1 == -1) return -1;
  return unify(op3,MAKEINT(op1));
}

int aux_number_vars__3(op1,n0)
register LONG op1;
int n0;
{
  register LONG_PTR sreg;
  register LONG op4;
  register int i,arity;
  
  LOCAL_OVERFLOW;
 label1:
 number_vars:
  switch (TAG(op1)) {
  case REF:
    NDEREF(op1,number_vars);
    ASSIGN_STRUCT(op1,dollar_var);
    NEW_HEAP_NODE(MAKEINT(n0));
    return n0+1;
    break;
  case ATM:
    return n0;
  case LST:
    sreg = (LONG_PTR)UNTAGGED(op1);
    op4 = *sreg++;
    op1 = *sreg;
    n0 = aux_number_vars__3(op4,n0);
    goto label1;
  case STR:
    UNTAG(op1);
    arity = GET_ARITY((SYM_REC_PTR)FOLLOW(op1));
    for (i=1;i<=arity;i++)
      n0 = aux_number_vars__3(*((LONG_PTR)op1+i),n0);
    return n0;
  }
}

c_COPY_TERM(){
  LONG term,cterm,temp;

  term = ARG(1,2); cterm = ARG(2,2);
  temp = copy_term(term);
  return unify(cterm,temp);
}

copy_term(term)
TERM term;
{
  LONG temp,tmp_op;
  LONG_PTR varVector,treg0;
  int maxVarNo=0;

  treg0 = treg;
  varVector = arreg-9;
  numberVarTerm(term,1);
  temp = unnumberVarTerm(term,varVector,&maxVarNo);
  UNDO_TRAILING;
  return temp;
}



