top :- 
    generate_list(1000,L),
    intersect(L,L,L1).

generate_list(N,L):-
    N=:=0,!,
    L=[].
generate_list(N,L):-
    L=[N|L1],
    N1 is N-1,
    generate_list(N1,L1).

intersect([],S2,S3):-
    S3=[].
intersect([X|Xs],S2,S3):-
    membchk1(X,S2),!,
    S3=[X|Ys],
    intersect(Xs,S2,Ys).
intersect([X|Xs],S2,S3):-
    intersect(Xs,S2,S3).

membchk1(X,[X|_]):-!.
membchk1(X,[_|L]):-
    membchk1(X,L).

    
