top :- true :
    generate_list(1000,L),
    intersect(L,L,L1).

generate_list(N,L):-
    N=:=0 :
    L:=[].
generate_list(N,L):-
    true :
    L:=[N|L1],
    N1 is N-1,
    generate_list(N1,L1).

intersect([],S2,S3):-
    true :
    S3:=[].
intersect([X|Xs],S2,S3):-
    membchk1(X,S2) :
    S3:=[X|Ys],
    intersect(Xs,S2,Ys).
intersect([X|Xs],S2,S3):-
    true :
    intersect(Xs,S2,S3).

membchk1(X,[X|_]):-true : true.
membchk1(X,[_|L]):-
    true :
    membchk1(X,L).

    
