/* simdef.h */

#include "basic.h"

BYTE     use_tabling = 0;
LONG_PTR tableArea;
LONG_PTR tableAreaBottom;
LONG     tableAreaSize;
LONG_PTR tareg;
LONG_PTR subgoalTable;
LONG subgoalTableBucketSize = 331;
LONG answerTableBucketSize = 31;

TOAM toam0;

LONG_PTR  memory;          /* heap, local stack */
LONG_PTR  pspace;          /* psc records, instructions, p-names */
LONG_PTR  tstack;          /* trail stack */
LONG      reg[MAXREGS];    /* general purpose registers */
LONG_PTR  rreg;	

LONG_PTR  local_bottom;
LONG_PTR  heap_bottom;
LONG_PTR  trail_bottom;

CHAR_PTR  curr_fence;      /* ptr to next free byte in perm space */
LONG_PTR  parea_top;      /* ptr to first free byte in the 2nd area*/
CHAR_PTR  max_fence;       /* ptr to last+1 free byte in perm space */
LONG_PTR  inst_begin;      /* ptr to the beginning of inst. array */
LONG_PTR  addr_rest_indomain;
LONG_PTR  addr_halt;
LONG_PTR  addr_halt0;

LONG_PTR  gc_low;
LONG_PTR  gc_upper;

LONG_PTR  top;
LONG_PTR  arreg;          /* last activation record       */
LONG_PTR  local_top;
LONG_PTR  breg;            /* last choice point            */
LONG_PTR  hreg;            /* top of heap                  */
LONG_PTR  treg;           /* top of trail stack           */
LONG_PTR  hbreg;           /* heap back track point        */
LONG_PTR  sreg;            /* current build or unify field */
LONG_PTR  sfreg;           /* latest suspension frame      */

LONG_PTR  triggers[MAXTRIGGERS];
BYTE event_flag[MAXTRIGGERS];
long int  trigger_no = 0;       /* list of woken frames         */
int       toam_signal_vec;

SYM_REC_PTR  hash_table[BUCKET_CHAIN];

BYTE      disassem;
int       num_line;        /* print instruction addresses on trace
                              and disassem */
BYTE      trace_toam = 0;

LONG      exception;
SYM_REC_PTR  list_psc;
SYM_REC_PTR  interrupt_psc;
SYM_REC_PTR  comma_psc;
SYM_REC_PTR  float_psc;
SYM_REC_PTR  enter_dyn_call;
SYM_REC_PTR  damon_load;
SYM_REC_PTR  slash_psc;
SYM_REC_PTR  domain_psc;
SYM_REC_PTR handle_exception_psc;
SYM_REC_PTR colon_sym,question_sym,
  imply_sym,clause4_sym,clause2_sym,
  clause_no_sym,domain_delta;

LONG  nil_sym, period_sym,varid;
LONG  atom_expected;
LONG  integer_expected;
LONG  number_expected;
LONG  arith_expr_expected;
LONG  list_expected;
LONG  structure_expected;
LONG  char_code_expected;
LONG  float_format_expected;
LONG  operator_type_expected;
LONG  variable_expected;
LONG  nonvariable_expected;
LONG  could_not_open_stream;
LONG  file_does_not_exist;
LONG  divide_by_zero;
LONG  illegal_expression;
LONG  illegal_list;
LONG  illegal_mode_string;
LONG  illegal_predicate;
LONG  not_modifiable;
LONG  out_of_range;
LONG  undefined_predicate;
LONG  illegal_file;
LONG  code_area_overflow;
LONG  permission_error;
LONG  control_stack_overflow;
LONG  trail_stack_overflow;
LONG  illegal_arguments;

LONG main_args;
