
#include "basic.h"
#include "inst.h"
#include "term.h"
#include <string.h>

init_sym(){

  SYM_REC_PTR insert(),insert_cfunc();

  nil_sym = ADDTAG(insert("[]", 2, 0),ATM);
  period_sym = ADDTAG(insert(".",1,0),ATM);
  
  list_psc = insert(".", 1, 2);
  comma_psc = insert(",", 1, 2);
  float_psc = insert("$float", 6, 3);
  enter_dyn_call = insert("dyn_call",8,1);
  damon_load = insert("$damon_load", 11, 0);
  interrupt_psc = insert("_$interrupt", 11, 0);
  GET_EP(interrupt_psc) = (int (*)())ADDTAG(toam0.breg,ATM);
  slash_psc = insert("/", 1, 2);
  domain_delta = insert("$domain_delta", 13, 2);
  domain_psc = insert("$domain",7,0);
  domain_psc->etype = T_BOOT;
  
  handle_exception_psc = insert_cfunc("handle_exception",2);
  
  atom_expected = ADDTAG(insert_cfunc("atom_expected",0),ATM);
  integer_expected = ADDTAG(insert_cfunc("integer_expected",0),ATM);
  number_expected = ADDTAG(insert_cfunc("number_expected",0),ATM);
  arith_expr_expected = ADDTAG(insert_cfunc("arith_expr_expected",0),ATM);
  list_expected = ADDTAG(insert_cfunc("list_expected",0),ATM);
  structure_expected = ADDTAG(insert_cfunc("structure_expected",0),ATM);
  char_code_expected = ADDTAG(insert_cfunc("char_code_expected",0),ATM);
  float_format_expected = ADDTAG(insert_cfunc("float_format_expected",0),ATM);
  operator_type_expected = ADDTAG(insert_cfunc("operator_type_expected",0),ATM);
  variable_expected = ADDTAG(insert_cfunc("variable_expected",0),ATM);
  nonvariable_expected = ADDTAG(insert_cfunc("nonvariable_expected",0),ATM);
  could_not_open_stream = ADDTAG(insert_cfunc("could_not_open_stream",0),ATM);
  file_does_not_exist = ADDTAG(insert_cfunc("file_does_not_exist",0),ATM);
  divide_by_zero = ADDTAG(insert_cfunc("divide_by_zero",0),ATM);
  illegal_expression = ADDTAG(insert_cfunc("illegal_expression",0),ATM);
  illegal_list = ADDTAG(insert_cfunc("illegal_list",0),ATM);
  illegal_mode_string = ADDTAG(insert_cfunc("illegal_mode_string",0),ATM);
  illegal_predicate = ADDTAG(insert_cfunc("illegal_predicate",0),ATM);
  not_modifiable = ADDTAG(insert_cfunc("not_modifiable",0),ATM);
  out_of_range = ADDTAG(insert_cfunc("out_of_range",0),ATM);
  undefined_predicate = ADDTAG(insert_cfunc("undefined_predicate",0),ATM);
  illegal_file = ADDTAG(insert_cfunc("illegal_file",0),ATM);
  code_area_overflow = ADDTAG(insert_cfunc("code_area_overflow",0),ATM);
  control_stack_overflow = ADDTAG(insert_cfunc("control_stack_overflow",0),ATM);
  trail_stack_overflow = ADDTAG(insert_cfunc("trail_stack_overflow",0),ATM);
  permission_error = ADDTAG(insert_cfunc("permission_error",0),ATM);

  illegal_arguments = ADDTAG(insert_cfunc("illegal_arguments",0),ATM);

  init_arith_sym();
  main_args = nil_sym;
}

 


