#include "basic.h"
#include "term.h"
#include "macro.h"

#define MAX_SIZE 128
#define SIZE_OF_HASHREC 3

typedef struct bt_node *NODE_PTR;

typedef struct bt_node {
  LONG value;
  LONG_PTR hashtab;
  int size,count;
  NODE_PTR prev,succ,first,last;
  LONG_PTR children;
} NODE;

typedef struct hashrec *HASHREC_PTR;

typedef struct hashrec {
  HASHREC_PTR next;
  LONG value;
  int index;
} HASHREC;

static LONG_PTR hashtabs[MAX_SIZE];

static int tabsizes[MAX_SIZE];

